﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Reflection;
using System.IO;

namespace HBDotNet
{
    public static class HBModule
    {
        #region callbacks to HouseBot

        public delegate void dlgtTraceDeviceMessage(IntPtr hDevice, TRC_TYPE trcType, string szMessage);
        public delegate void dlgtResetSunRiseAndSunSetTimes();
        public delegate bool dlgtGetDevicePropertyValueFromPropertyHandle(IntPtr hProperty, out IntPtr hPropertyValue, out string szPropertyValue, out string szConfigValue);
        public delegate bool dlgtGetDevicePropertyValueFromHandle(IntPtr hProperyValue, out string szPropertyValue, out string szConfigValue);
        public delegate bool dlgtRegisterDeviceProperty(IntPtr hDeviceModule, int nDeviceNumber, string szPropertyName, string szPropertyDescription, bool bDefault, string szInitialValue, eIOType ioType, bool bPersistent, bool bAllowSameValueChange, bool bTraceToDeviceLog, bool bDynamic);
        public delegate bool dlgtGetPropertyInfoFromHandle(IntPtr hProperty, StringBuilder szPropertyName, StringBuilder szPropertyDescription);
        public delegate IntPtr dlgtGetDevicePropertyHandleFromName(IntPtr hDevice, string szPropertyName, StringBuilder szPropertyDescription);
        public delegate IntPtr dlgtCreatePropertyValue(IntPtr hProperty, string szNewValue);
        public delegate bool dlgtGetIRCodeArrayAssociatedWithPropertyValue(IntPtr hProperty, IntPtr hPropertyValue, ref ushort[] pRetArray, ref uint pdwBufferSize);
        public delegate void dlgtChangeRequest(IntPtr hPropertyValue);
        public delegate void dlgtChangeRequestCompleted(IntPtr hPropertyValue);
        public delegate void dlgtChangeRequestFailed(IntPtr hPropertyValue);
        public delegate IntPtr dlgtGetPropertyHandleFromPropertyValueHandle(IntPtr hPropertyValue);
        public delegate HARDWARE_RC dlgtSendInterfacePackToInterface(IntPtr hDevice, IntPtr pPack);
        public delegate void dlgtSubscribeToNotificationList(IntPtr hDevice, string szListName, string szFilter);
        public delegate void dlgtUnSubscribeFromNotificationList(IntPtr hDevice, string szListName, string szFilter);
        public delegate bool dlgtGetDeviceInfoFromDescription(string szDeviceDescription, out IntPtr hDevice, out bool bEnabled, out string szDeviceName);
        public delegate bool dlgtGetPropertyInfoByDescription(IntPtr hDevice, string szPropertyDescription, out IntPtr hProperty, StringBuilder szPropertyName);
        public delegate bool dlgtClearArrayPropertyValue(IntPtr hPropertyValue);
        public delegate bool dlgtAddArrayPropertyValue(IntPtr hPropertyValue, string szValue);
        public delegate string dlgtGetArrayPropertyValueAsStringAtIndex(IntPtr hPropertyValue, int nIndex);
        public delegate string dlgtGetModeStateByName(string szModeName);
        public delegate bool dlgtSetModeStateByName(string szModeName, bool bActive);
        public delegate bool dlgtExecuteTaskByName(string szTaskName);
        public delegate bool dlgtIsTaskRunning(string szTaskName);
        public delegate void dlgtStopTaskByName(string szTaskName);
        //public delegate bool dlgtGetWinMsgArrayAssociatedWithPropertyValue(....
        public delegate bool dlgtCreateDeviceProperty(string szPropertyName, string szPropertyDescription, ePropertyType ptType);
        public delegate bool dlgtCreateDevicePropertyValue(string szPropertyName, string szPropertyValue);
        public delegate bool dlgtCreateDevicePropertyMapping(IntPtr hDevice, string szPropertyName, string szPropertyDescription, string szInitialValue, eIOType ioType, bool bDefault, bool bPersistent, bool bAllowSameValueChange, bool bTraceToDevLog, bool bDynamic);
        public delegate int dlgtGetDeviceID(IntPtr hDevice);
        public delegate bool dlgtAddNewPropertyValue(IntPtr hProperty, string szNewValue);
        //public delegate bool dlgtGetGenericCommansAssociatedWithValue(...
        public delegate bool dlgtQueryHardwareInstance(IntPtr hDevice, string szQuery, IntPtr pResponse);
        public delegate void dlgtChangeRequestAbandoned(IntPtr hPropertyValue);
        public delegate bool dlgtControlRemote(eClientControlAction ccaAction, string szWhichRemotes, string pArg1, string pArg2);
        public delegate bool dlgtGetDeviceList(StringBuilder pszDeviceList, ref uint pdwBufferSize, string szDelimiter);
        public delegate bool dlgtGetPropertyListForDevice(string szDeviceDescription, StringBuilder pszPropertyList, ref uint pdwBufferSize, string szDelimiter);
        public delegate bool dlgtGetPropertyValueListForProperty(string szPropertyDescription, StringBuilder pszValueList, ref uint pdwBufferSize, string szDelimiter);
        public delegate bool dlgtGetTaskList(StringBuilder pszTaskList, ref uint pdwBufferSize, string szDelimiter);
        public delegate bool dlgtGetModeList(StringBuilder pszModeLIst, ref uint pdwBufferSize, string szDelimiter);
        public delegate bool dlgtRegisterDevicePropertyUsingWizard(IntPtr hDeviceModule, int nDeviceNumber, string szPropertyName, string szPropertyDescription, bool bDefault, string szInitialValue, eIOType ioType, bool bPersistent, bool bAllowSameValueChange, bool bTraceToDeviceLog, bool bDynamic, string szWizardText);
        public delegate bool dlgtRegisterDeviceButton(IntPtr hDeviceModule, int nDeviceNumber, int nButtonCallbackID, string szButtonHeading, string szButtonText);
        public delegate bool dlgtGetAndRemoveNextChangeRequestOnQueue2(IntPtr hDevice, out IntPtr phProperty, out IntPtr phPropertyValue, StringBuilder szPropertyName, StringBuilder szPropertyDescription, StringBuilder szPropertyValue, ref int nPropertyValueLen, StringBuilder szConfigValue, ref int nConfigValueLen);
        public delegate bool dlgtSubscribeToPropertyChange(IntPtr hDevice, string szDeviceDescription, string szPropertyDescription);
        public delegate bool dlgtUnsubscribeFromPropertyChange(IntPtr hDevice, string szDeviceDescription, string szPropertyDescription);
        public delegate bool dlgtRegisterAndCreateDeviceProperty(IntPtr hDeviceModule, int nDeviceNumber, string szPropertyName, string szPropertyDescription, bool bDefault, string szInitialValue, eIOType ioType, bool bPersistent, bool bAllowSameValueChange, bool bTraceToDeviceLog, bool bDynamic, ePropertyType ptType, string szWizardText);
        public delegate bool dlgtGetIRNumericArrayForRemoteAssociatedToValue(IntPtr hProperty, IntPtr hPropertyValue, ref ushort[] pRetArray);

        public static dlgtTraceDeviceMessage TraceDeviceMessage;
        public static dlgtResetSunRiseAndSunSetTimes ResetSunRiseAndSunSetTimes;
        public static dlgtGetDevicePropertyValueFromPropertyHandle GetDevicePropertyValueFromPropertyHandle;
        public static dlgtGetDevicePropertyValueFromHandle GetDevicePropertyValueFromHandle;
        public static dlgtRegisterDeviceProperty RegisterDeviceProperty;
        public static dlgtGetPropertyInfoFromHandle GetPropertyInfoFromHandle;
        public static dlgtGetDevicePropertyHandleFromName GetDevicePropertyHandleFromName;
        public static dlgtCreatePropertyValue CreatePropertyValue;
        public static dlgtGetIRCodeArrayAssociatedWithPropertyValue GetIRCodeArrayAssociatedWithPropertyValue;
        public static dlgtChangeRequest ChangeRequest;
        public static dlgtChangeRequestCompleted ChangeRequestCompleted;
        public static dlgtChangeRequestFailed ChangeRequestFailed;
        public static dlgtGetPropertyHandleFromPropertyValueHandle GetPropertyHandleFromPropertyValueHandle;
        public static dlgtSendInterfacePackToInterface SendInterfacePackToInterface;
        public static dlgtSubscribeToNotificationList SubscribeToNotificationList;
        public static dlgtUnSubscribeFromNotificationList UnSubscribeFromNotificationList;
        public static dlgtGetDeviceInfoFromDescription GetDeviceInfoFromDescription;
        public static dlgtGetPropertyInfoByDescription GetPropertyInfoByDescription;
        public static dlgtClearArrayPropertyValue ClearArrayPropertyValue;
        public static dlgtAddArrayPropertyValue AddArrayPropertyValue;
        public static dlgtGetArrayPropertyValueAsStringAtIndex GetArrayPropertyValueAsStringAtIndex;
        public static dlgtGetModeStateByName GetModeStateByName;
        public static dlgtSetModeStateByName SetModeStateByName;
        public static dlgtExecuteTaskByName ExecuteTaskByName;
        public static dlgtIsTaskRunning IsTaskRunning;
        public static dlgtStopTaskByName StopTaskByName;
        //public static dlgtGetWinMsgArrayAssociatedWithPropertyValue(....
        public static dlgtCreateDeviceProperty CreateDeviceProperty;
        public static dlgtCreateDevicePropertyValue CreateDevicePropertyValue;
        public static dlgtCreateDevicePropertyMapping CreateDevicePropertyMapping;
        public static dlgtGetDeviceID GetDeviceID;
        public static dlgtAddNewPropertyValue AddNewPropertyValue;
        //public static dlgtGetGenericCommansAssociatedWithValue(...
        public static dlgtQueryHardwareInstance QueryHardwareInstance;
        public static dlgtChangeRequestAbandoned ChangeRequestAbandoned;
        public static dlgtControlRemote ControlRemote;
        public static dlgtGetDeviceList GetDeviceList;
        public static dlgtGetPropertyListForDevice GetPropertyListForDevice;
        public static dlgtGetPropertyValueListForProperty GetPropertyValueListForProperty;
        public static dlgtGetTaskList GetTaskList;
        public static dlgtGetModeList GetModeList;
        public static dlgtRegisterDevicePropertyUsingWizard RegisterDevicePropertyUsingWizard;
        public static dlgtRegisterDeviceButton RegisterDeviceButton;
        public static dlgtGetAndRemoveNextChangeRequestOnQueue2 GetAndRemoveNextChangeRequestOnQueue2;
        public static dlgtSubscribeToPropertyChange SubscribeToPropertyChange;
        public static dlgtUnsubscribeFromPropertyChange UnsubscribeFromPropertyChange;
        public static dlgtRegisterAndCreateDeviceProperty RegisterAndCreateDeviceProperty;
        public static dlgtGetIRNumericArrayForRemoteAssociatedToValue GetIRNumericArrayForRemoteAssociatedToValue;

        #endregion

        #region Implementation of HouseBot module calls

        private static DeviceList _devices = new DeviceList();

        private static IntPtr _moduleHandle = IntPtr.Zero;
        public static IntPtr ModuleHandle
        {
            get { return _moduleHandle; }
        }

        private static string _HBVersion = string.Empty;
        public static string HBVersion
        {
            get { return _HBVersion; }
        }

        private static string _DLLPathAndFileName;
        public static string DLLPathAndFileName
        {
            get { return _DLLPathAndFileName; }
        }

        private static void ProcessFile(string fileName)
        {
            System.Diagnostics.Debug.WriteLine("Processing File: " + fileName);
            try
            {
                // Try to load the assembly
                Assembly asm = Assembly.LoadFile(fileName);

                // get the list of types it exports and scan through them
                Type[] types = asm.GetExportedTypes();
                foreach (Type T in types)
                {

                    // See if this type derives from HBDeviceBase
                    if (T.IsSubclassOf(typeof(HBDeviceBase)))
                    {
                        // Yes! Get the default constructor
                        ConstructorInfo ci = T.GetConstructor(Type.EmptyTypes);
                        if (ci != null)
                        {
                            // invoke it to create the object
                            HBDeviceBase device = (HBDeviceBase)ci.Invoke(null);
                            device.DeviceNumber = _devices.Count;
                            _devices.Add(device);
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                System.Diagnostics.Debug.WriteLine("-- file no good: " + ex.ToString());
            }
            
        }

        public static bool HBDeviceModuleInit(IntPtr moduleHandle, string HBVersion, string DLLPathAndFileName)
        {
            System.Diagnostics.Debug.WriteLine("HBDeviceModuleInit from C#");
            _moduleHandle = moduleHandle;
            _HBVersion = HBVersion;
            _DLLPathAndFileName = DLLPathAndFileName;

            // scan through the plugins folder and find assemblies with classes that derive from HBDeviceBase
            string dirName = Path.GetDirectoryName(_DLLPathAndFileName);
            foreach (string fileName in Directory.GetFiles(dirName, "*.dll"))
            {
                ProcessFile(fileName);
            }
             
            return true;
        }

        public static bool HBGetDeviceInfo(int deviceNumber, out DeviceInfo deviceInfo)
        {
            System.Diagnostics.Debug.WriteLine("HBGetDeviceInfo from C# (" + deviceNumber.ToString() + ")");
            if (deviceNumber < _devices.Count)
            {
                HBDeviceBase device = _devices[deviceNumber];
                deviceInfo = device.GetDeviceInfo();
                return true;
            }
            else
            {
                deviceInfo = new DeviceInfo();
                return false;
            }
        }

        public static bool HBDeviceRegisterProperties(int deviceNumber)
        {
            if (deviceNumber < _devices.Count)
            {
                HBDeviceBase device = _devices[deviceNumber];
                device.OnRegisterProperties();
                return true;
            }
            else
            {
                return false;
            }
        }

        public static bool HBDeviceInit(IntPtr deviceHandle, bool enabled, string deviceName, string deviceDescription)
        {
            System.Diagnostics.Debug.WriteLine("HBDeviceInit C#: " + deviceName);

            HBDeviceBase device = _devices.GetDeviceByName(deviceName);
            if (device == null) return false;

            device.DeviceHandle = deviceHandle;
            return device.OnInit(enabled);
        }

        public static bool HBDeviceSetEnabled(IntPtr deviceHandle, bool enabled)
        {
            HBDeviceBase device = _devices.GetDeviceByHandle(deviceHandle);
            if (device == null) return false;
            return device.SetEnabled(enabled);
        }

        public static bool HBDeviceRun(IntPtr deviceHandle, IntPtr hTerminate, IntPtr hPropertyChangeRequest)
        {
            HBDeviceBase device = _devices.GetDeviceByHandle(deviceHandle);
            if (device == null) return false;
            return device.Run(hTerminate, hPropertyChangeRequest);
        }

        public static void HBDisplayHelp(string deviceName)
        {
            HBDeviceBase device = _devices.GetDeviceByName(deviceName);
            if (device == null) return;
            device.OnDisplayHelp();
        }

        public static void HBAboutBox(string deviceName)
        {
            HBDeviceBase device = _devices.GetDeviceByName(deviceName);
            if (device == null) return;
            device.OnAboutBox();
        }

        public static void HBDeviceButtonPressNotification(IntPtr deviceHandle, int buttonId)
        {
            HBDeviceBase device = _devices.GetDeviceByHandle(deviceHandle);
            if (device == null) return;
            device.OnButtonPressNotification(buttonId);
        }

        public static bool HBDeviceSubscriptionNotification(IntPtr deviceHandle, string listName, string filter, IntPtr dataPack)
        {
            HBDeviceBase device = _devices.GetDeviceByHandle(deviceHandle);
            if (device == null) return false;
            return device.OnSubscriptionNotification(listName, filter, dataPack);
        }

        public static void HBPropertyChangeNotification(IntPtr deviceHandle, string deviceDescription, string propertyDescription, string newValue)
        {
            HBDeviceBase device = _devices.GetDeviceByHandle(deviceHandle);
            if (device == null) return;
            device.OnPropertyChangeNotification(deviceDescription, propertyDescription, newValue);
        }

        /*
        public static bool HBDeviceInitDynamicProperty(IntPtr deviceHandle, IntPtr propertyHandle)
        {
            return false;
        }

        public static bool HBDeviceSetDynamicProperty(IntPtr deviceHandle, IntPtr propertyHandle, string value, int index)
        {
            return false;
        }

        public static bool HBDeviceDeleteDynamicProperty(IntPtr deviceHandle, IntPtr propertyHandle, int index)
        {
            return false;
        }

        public static bool HBDeviceMoveItemDownDynamicProperty(IntPtr deviceHandle, IntPtr propertyHandle, int index)
        {
            return false;
        }

        public static bool HBDeviceMoveItemUpDynamicProperty(IntPtr deviceHandle, IntPtr propertyHandle, int index)
        {
            return false;
        }
        */
        #endregion

    }
}
