﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HBDotNet
{
    [AttributeUsage(AttributeTargets.Class, AllowMultiple=true, Inherited = false)]
    public class HBPropertyAttribute : Attribute
    {
        protected string _name = string.Empty;
        protected string _description = string.Empty;
        protected bool _isDefault = false;
        protected string _initialValue = string.Empty;
        protected eIOType _ioType = eIOType.ioUnknown;
        protected bool _isPersistent = false;
        protected bool _allowSameValueChange = false;
        protected bool _traceToDeviceLog = false;
        protected bool _isDynamic = false;
        protected ePropertyType _propertyType = ePropertyType.ptAlpha;
        protected string _wizardText = string.Empty;

        public string Name
        {
            get { return _name; }
        }

        public string Description
        {
            get { return _description; }
            set { _description = value; }
        }

        public bool IsDefault
        {
            get { return _isDefault; }
            set { _isDefault = value; }
        }

        public string InitialValue
        {
            get { return _initialValue; }
            set { _initialValue = value; }
        }

        public eIOType IOType
        {
            get { return _ioType; }
            set { _ioType = value; }
        }

        public bool IsPersistent
        {
            get { return _isPersistent; }
            set { _isPersistent = value; }
        }

        public bool AllowSameValueChange
        {
            get { return _allowSameValueChange; }
            set { _allowSameValueChange = value; }
        }

        public bool TraceToDeviceLog
        {
            get { return _traceToDeviceLog; }
            set { _traceToDeviceLog = value; }
        }

        public bool IsDynamic
        {
            get { return _isDynamic; }
            set { _isDynamic = value; }
        }

        public ePropertyType PropertyType
        {
            get { return _propertyType; }
            set { _propertyType = value; }
        }

        public string WizardText
        {
            get { return _wizardText; }
            set { _wizardText = value; }
        }


        public HBPropertyAttribute(string propertyName, ePropertyType propertyType, string initialValue)
        {
            _name = propertyName;
            _description = propertyName;
            _propertyType = propertyType;
            _initialValue = initialValue;
        }
    }
}