﻿using System;
using System.Collections.Generic;
using System.Text;

namespace HBDotNet
{
    public class HBPropertyList
    {
        private List<HBProperty> _properties = new List<HBProperty>();
        private HBDeviceBase _owner = null;

        public HBPropertyList(HBDeviceBase owner)
        {
            _owner = owner;
        }

        public HBProperty GetPropertyByName(string name)
        {
            foreach (HBProperty prop in _properties)
            {
                if (prop.Name == name) return prop;
            }
            return null;
        }

        public HBProperty GetPropertyByHandle(IntPtr handle)
        {
            foreach (HBProperty prop in _properties)
            {
                if (prop.Handle == handle) return prop;
            }
            return null;
        }

        public HBProperty this[int index]
        {
            get { return _properties[index]; }
        }

        public void Add(HBProperty property)
        {
            property.Owner = this._owner;
            property.Register();
            _properties.Add(property);
        }

    }
}
