// This is the main DLL file.

#include "stdafx.h"
#include "HBDotNetBridge.h"

#pragma managed
#include "vcclr.h"
#using "..\\HBDotNet\\bin\\Debug\\HBDotNet.dll"
using namespace System;
using namespace System::Runtime;
using namespace System::Runtime::InteropServices;
using namespace HBDotNet;
#pragma unmanaged

// ====================================================================
// Method Name : DllMain
// Description : Standard Windows DLL entry point.
// ====================================================================
BOOL APIENTRY DllMain( HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
	}
	return (TRUE);
}

// Module information that is returned to the server on HBDeviceModuleInit()
ModuleInfo  g_ModuleInfo =
{  
	0,                               // Initialized at runtime to the sizeof() this structure
	"1.00",                          // Plugin version number
	"DotNet Bridge",				 // Plugin name
};

// Globally stored server callback info.  It is passed only once to the plugin, but needs
// to be passed to each device instance when created later.
DeviceCallBackInfo  g_CallBackInfo;

// Globally stored managed HBModule
#pragma managed
class HBModuleWrapper
{
public:
	HBModuleWrapper()
	{
	}

	bool HBDeviceModuleInit( DeviceCallBackInfo *pCallBackInfo )
	{
		// Setup All the delegates
		HBModule::TraceDeviceMessage						= (HBModule::dlgtTraceDeviceMessage^) Marshal::GetDelegateForFunctionPointer( (IntPtr)pCallBackInfo->pHB_TraceDeviceMessage, HBModule::dlgtTraceDeviceMessage::typeid );
		HBModule::ResetSunRiseAndSunSetTimes				= (HBModule::dlgtResetSunRiseAndSunSetTimes^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_ResetSunRiseAndSunSetTimes, HBModule::dlgtResetSunRiseAndSunSetTimes::typeid );
		HBModule::GetDevicePropertyValueFromPropertyHandle	= (HBModule::dlgtGetDevicePropertyValueFromPropertyHandle^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetDevicePropertyValueFromPropertyHandle, HBModule::dlgtGetDevicePropertyValueFromPropertyHandle::typeid );
		HBModule::GetDevicePropertyValueFromHandle			= (HBModule::dlgtGetDevicePropertyValueFromHandle^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetDevicePropertyValueFromHandle, HBModule::dlgtGetDevicePropertyValueFromHandle::typeid );
		HBModule::RegisterDeviceProperty					= (HBModule::dlgtRegisterDeviceProperty^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_RegisterDeviceProperty, HBModule::dlgtRegisterDeviceProperty::typeid );
		HBModule::GetPropertyInfoFromHandle					= (HBModule::dlgtGetPropertyInfoFromHandle^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetPropertyInfoFromHandle, HBModule::dlgtGetPropertyInfoFromHandle::typeid );
		HBModule::GetDevicePropertyHandleFromName			= (HBModule::dlgtGetDevicePropertyHandleFromName^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetDevicePropertyHandleFromName, HBModule::dlgtGetDevicePropertyHandleFromName::typeid );
		HBModule::CreatePropertyValue						= (HBModule::dlgtCreatePropertyValue^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_CreatePropertyValue, HBModule::dlgtCreatePropertyValue::typeid );
		HBModule::GetIRCodeArrayAssociatedWithPropertyValue = (HBModule::dlgtGetIRCodeArrayAssociatedWithPropertyValue^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetIRCodeArrayAssociatedWithPropertyValue, HBModule::dlgtGetIRCodeArrayAssociatedWithPropertyValue::typeid );
		HBModule::ChangeRequest								= (HBModule::dlgtChangeRequest^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_ChangeRequest, HBModule::dlgtChangeRequest::typeid );
		HBModule::ChangeRequestCompleted					= (HBModule::dlgtChangeRequestCompleted^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_ChangeRequestCompleted, HBModule::dlgtChangeRequestCompleted::typeid );
		HBModule::ChangeRequestFailed						= (HBModule::dlgtChangeRequestFailed^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_ChangeRequestFailed, HBModule::dlgtChangeRequestFailed::typeid );
		HBModule::GetPropertyHandleFromPropertyValueHandle	= (HBModule::dlgtGetPropertyHandleFromPropertyValueHandle^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetPropertyHandleFromPropertyValueHandle, HBModule::dlgtGetPropertyHandleFromPropertyValueHandle::typeid );
		HBModule::SendInterfacePackToInterface				= (HBModule::dlgtSendInterfacePackToInterface^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_SendInterfacePackToInterface, HBModule::dlgtSendInterfacePackToInterface::typeid );
		HBModule::SubscribeToNotificationList				= (HBModule::dlgtSubscribeToNotificationList^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_SubscribeToNotificationList, HBModule::dlgtSubscribeToNotificationList::typeid );
		HBModule::UnSubscribeFromNotificationList			= (HBModule::dlgtUnSubscribeFromNotificationList^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_UnSubscribeFromNotificationList, HBModule::dlgtUnSubscribeFromNotificationList::typeid );
		HBModule::GetDeviceInfoFromDescription				= (HBModule::dlgtGetDeviceInfoFromDescription^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetDeviceInfoFromDescription, HBModule::dlgtGetDeviceInfoFromDescription::typeid );
		HBModule::GetPropertyInfoByDescription				= (HBModule::dlgtGetPropertyInfoByDescription^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetPropertyInfoByDescription, HBModule::dlgtGetPropertyInfoByDescription::typeid );
		HBModule::ClearArrayPropertyValue					= (HBModule::dlgtClearArrayPropertyValue^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_ClearArrayPropertyValue, HBModule::dlgtClearArrayPropertyValue::typeid );
		HBModule::AddArrayPropertyValue						= (HBModule::dlgtAddArrayPropertyValue^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_AddArrayPropertyValue, HBModule::dlgtAddArrayPropertyValue::typeid );
		HBModule::GetArrayPropertyValueAsStringAtIndex		= (HBModule::dlgtGetArrayPropertyValueAsStringAtIndex^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetArrayPropertyValueAsStringAtIndex, HBModule::dlgtGetArrayPropertyValueAsStringAtIndex::typeid );
		HBModule::GetModeStateByName						= (HBModule::dlgtGetModeStateByName^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetModeStateByName, HBModule::dlgtGetModeStateByName::typeid );
		HBModule::SetModeStateByName						= (HBModule::dlgtSetModeStateByName^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_SetModeStateByName, HBModule::dlgtSetModeStateByName::typeid );
		HBModule::ExecuteTaskByName							= (HBModule::dlgtExecuteTaskByName^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_ExecuteTaskByName, HBModule::dlgtExecuteTaskByName::typeid );
		HBModule::IsTaskRunning								= (HBModule::dlgtIsTaskRunning^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_IsTaskRunning, HBModule::dlgtIsTaskRunning::typeid );
		HBModule::StopTaskByName							= (HBModule::dlgtStopTaskByName^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_StopTaskByName, HBModule::dlgtStopTaskByName::typeid );
		HBModule::CreateDeviceProperty						= (HBModule::dlgtCreateDeviceProperty^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_CreateDeviceProperty, HBModule::dlgtCreateDeviceProperty::typeid );
		HBModule::CreateDevicePropertyValue					= (HBModule::dlgtCreateDevicePropertyValue^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_CreateDevicePropertyValue, HBModule::dlgtCreateDevicePropertyValue::typeid );
		HBModule::CreateDevicePropertyMapping				= (HBModule::dlgtCreateDevicePropertyMapping^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_CreateDevicePropertyMapping, HBModule::dlgtCreateDevicePropertyMapping::typeid );
		HBModule::GetDeviceID								= (HBModule::dlgtGetDeviceID^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetDeviceID, HBModule::dlgtGetDeviceID::typeid );
		HBModule::AddNewPropertyValue						= (HBModule::dlgtAddNewPropertyValue^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_AddNewPropertyValue, HBModule::dlgtAddNewPropertyValue::typeid );
		HBModule::QueryHardwareInstance						= (HBModule::dlgtQueryHardwareInstance^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_QueryHardwareInstance, HBModule::dlgtQueryHardwareInstance::typeid );
		HBModule::ChangeRequestAbandoned					= (HBModule::dlgtChangeRequestAbandoned^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_ChangeRequestAbandoned, HBModule::dlgtChangeRequestAbandoned::typeid );
		HBModule::ControlRemote								= (HBModule::dlgtControlRemote^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_ControlRemote, HBModule::dlgtControlRemote::typeid );
		HBModule::GetDeviceList								= (HBModule::dlgtGetDeviceList^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetDeviceList, HBModule::dlgtGetDeviceList::typeid );
		HBModule::GetPropertyListForDevice					= (HBModule::dlgtGetPropertyListForDevice^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetPropertyListForDevice, HBModule::dlgtGetPropertyListForDevice::typeid );
		HBModule::GetPropertyValueListForProperty			= (HBModule::dlgtGetPropertyValueListForProperty^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetPropertyValueListForProperty, HBModule::dlgtGetPropertyValueListForProperty::typeid );
		HBModule::GetTaskList								= (HBModule::dlgtGetTaskList^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetTaskList, HBModule::dlgtGetTaskList::typeid );
		HBModule::GetModeList								= (HBModule::dlgtGetModeList^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetModeList, HBModule::dlgtGetModeList::typeid );
		HBModule::RegisterDevicePropertyUsingWizard			= (HBModule::dlgtRegisterDevicePropertyUsingWizard^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_RegisterDevicePropertyUsingWizard, HBModule::dlgtRegisterDevicePropertyUsingWizard::typeid );
		HBModule::RegisterDeviceButton						= (HBModule::dlgtRegisterDeviceButton^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_RegisterDeviceButton, HBModule::dlgtRegisterDeviceButton::typeid );
		HBModule::GetAndRemoveNextChangeRequestOnQueue2		= (HBModule::dlgtGetAndRemoveNextChangeRequestOnQueue2^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetAndRemoveNextChangeRequestOnQueue2, HBModule::dlgtGetAndRemoveNextChangeRequestOnQueue2::typeid );
		HBModule::SubscribeToPropertyChange					= (HBModule::dlgtSubscribeToPropertyChange^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_SubscribeToPropertyChange, HBModule::dlgtSubscribeToPropertyChange::typeid );
		HBModule::UnsubscribeFromPropertyChange				= (HBModule::dlgtUnsubscribeFromPropertyChange^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_UnsubscribeFromPropertyChange, HBModule::dlgtUnsubscribeFromPropertyChange::typeid );
		HBModule::RegisterAndCreateDeviceProperty			= (HBModule::dlgtRegisterAndCreateDeviceProperty^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_RegisterAndCreateDeviceProperty, HBModule::dlgtRegisterAndCreateDeviceProperty::typeid );
		HBModule::GetIRNumericArrayForRemoteAssociatedToValue = (HBModule::dlgtGetIRNumericArrayForRemoteAssociatedToValue^) Marshal::GetDelegateForFunctionPointer( (IntPtr) pCallBackInfo->pHB_GetIRNumericArrayForRemoteAssociatedToValue, HBModule::dlgtGetIRNumericArrayForRemoteAssociatedToValue::typeid );


		// call the module
		return HBModule::HBDeviceModuleInit( (IntPtr) pCallBackInfo->m_hModuleHandle, gcnew String( pCallBackInfo->m_szHBVersion ), gcnew String( pCallBackInfo->m_szDLLPathAndFileName ) );
	}

	bool HBGetDeviceInfo( int nDeviceNumber, ::DeviceInfo ** ppDeviceInfo )
	{
		HBDotNet::DeviceInfo d;
		if (HBModule::HBGetDeviceInfo( nDeviceNumber, d ))
		{
			d.m_nDeviceInfoSize = Marshal::SizeOf(d);
			IntPtr p = Marshal::AllocHGlobal( d.m_nDeviceInfoSize );
			Marshal::StructureToPtr(d, p, false);
			*ppDeviceInfo = (::DeviceInfo *)p.ToPointer();
			return true;
		}
		else
		{
			return false;
		}
	}

	bool HBDeviceRegisterProperties( int nDeviceNumber )
	{
		return HBModule::HBDeviceRegisterProperties( nDeviceNumber );
	}

	bool HBDeviceInit( DEVICE_HANDLE hDevice, BOOL bEnabled, const char* szDeviceName, const char* szDeviceDescription )
	{
		return HBModule::HBDeviceInit( 
			(IntPtr)hDevice, 
			bEnabled, 
			gcnew String(szDeviceName), 
			gcnew String(szDeviceDescription) );
	}

	bool HBDeviceSetEnabled( DEVICE_HANDLE hDevice, BOOL bEnabled )
	{
		return HBModule::HBDeviceSetEnabled( (IntPtr)hDevice, bEnabled );
	}

	bool HBDeviceRun( DEVICE_HANDLE hDevice, HANDLE hTerminate, HANDLE hPropertyChangeRequest )
	{
		return HBModule::HBDeviceRun( 
			(IntPtr) hDevice,
			(IntPtr) hTerminate,
			(IntPtr) hPropertyChangeRequest );
	}

	void HBDisplayHelp( const char* szDeviceName )
	{
		HBModule::HBDisplayHelp( gcnew String(szDeviceName) );
	}

	void HBAboutBox( const char* szDeviceName )
	{
		HBModule::HBAboutBox( gcnew String(szDeviceName) );
	}

	void HBDeviceButtonPressNotification( DEVICE_HANDLE hDevice, int nButtonID )
	{
		HBModule::HBDeviceButtonPressNotification( (IntPtr)hDevice, nButtonID );
	}

	bool HBDeviceSubscriptionNotification( DEVICE_HANDLE hDevice, LPCTSTR szListName, LPCTSTR szFilter, CDataPack* pDataPack )
	{
		return HBModule::HBDeviceSubscriptionNotification(
			(IntPtr) hDevice, 
			gcnew String(szListName),
			gcnew String(szFilter),
			(IntPtr) pDataPack  );
	}

	void HBPropertyChangeNotification( DEVICE_HANDLE hDevice, const char* szDeviceDescription, const char* szPropertyDescription, const char* szNewValue )
	{
		HBModule::HBPropertyChangeNotification(
			(IntPtr) hDevice,
			gcnew String(szDeviceDescription),
			gcnew String(szPropertyDescription),
			gcnew String(szNewValue) );
	}
};
#pragma unmanaged

HBModuleWrapper * g_pWrapper;


// ====================================================================
// Method Name : HBDeviceModuleInit
// Description : This function is called by the server only once on
//                initial load of the plugin.  It requests information
//                about the plugin and provides server callback
//                information.
// Parameters  :  DeviceCallBackInfo* - A pointer to a DeviceCallBackInfo
//                   structure.  This structure includes the server version
//                   number, the module handle, full path and filename where
//                   the plugin was loaded, and pointers to all server
//                   callback functions.  This structure should be stored and
//                   used for all instances of the Device.
//                   !!== Do not store the pointer to the structure.  Make a
//                   copy of the data.==!!
//                ModuleInfo** - A pointer to a pointer to allow the plugin to
//                   return to the server a ModuleInfo structure that gives
//                   general information about the plugin.  The m_nModuleInfoSize
//                   member must be initialized to the sizeof() the structure.
//                   This allows for backward compatibility if the structure is
//                   amended in the future.
// Returns     : Returns TRUE if successful.  Returns FALSE if unsuccessful.
// ====================================================================
HOUSEBOT_DEVICE_API BOOL HBDeviceModuleInit( DeviceCallBackInfo* pCallBackInfo, ModuleInfo** ppModuleInfo )
{
	//
	// Make copy of the callback structure passed by server!!
	memcpy( &g_CallBackInfo, pCallBackInfo, sizeof( DeviceCallBackInfo ) );

	//
	// Initialize the size of the module.
	g_ModuleInfo.m_nModuleInfoSize = sizeof( ModuleInfo );

	//
	// Assign our module info to the supplied pointer.
	*ppModuleInfo = &g_ModuleInfo;

	//
	// Create our managed object
	g_pWrapper = new HBModuleWrapper();
	g_pWrapper->HBDeviceModuleInit(pCallBackInfo);
	return( TRUE );
}

// ====================================================================
// Method Name : HBGetDeviceInfo
// Description : The server calls this function to query the plugin for
//                information on each of its supported Devices.  This
//                function is called multiple times to individually
//                query each Device definition.
// Parameters  : int nDeviceNumber - Specifies the Device number (ordinal)
//                that the server is requesting information about.  This
//                always starts with 0 and continues to be called with
//                incrementing nDeviceNumbers until FALSE is returned due
//                to no more Devices to report.
//               DeviceInfo** - A pointer to a pointer to allow the plugin
//                to return to the server a DeviceInfo structure that gives
//                specific information about the Device referenced by
//                nDeviceNumber.  The m_nDeviceInfoSize member must be
//                initialized to the sizeof() the structure.  This allows
//                for backward compatibility if the structure is amended
//                in the future.
// Returns     : Returns TRUE if the device number exists.
//                Returns FALSE if device number does not exist.
// ====================================================================
HOUSEBOT_DEVICE_API BOOL HBGetDeviceInfo( int nDeviceNumber, ::DeviceInfo** ppDeviceInfo )
{
	return g_pWrapper->HBGetDeviceInfo( nDeviceNumber, ppDeviceInfo );
}

// ====================================================================
// Method Name : HBDeviceRegisterProperties
// Description : The server calls this function to allow the plugin to
//                register properties for a particular instance.  All
//                properties should be registered when this function is
//                called.  Do not register properties before this
//                function is called.  This function is also called on
//                the plugin for each Device reported by
//                HBGetDeviceInfo() regardless of whether an instance
//                is created or not.
// Parameters  :  int nDeviceNumber - Device Number (ordinal) to register
//                   properties for.  This Device Number must match the
//                   Device number definition given in HBGetDeviceInfo().
// Returns     :  Returns TRUE if the instance has successfully registered
//                   its properties.  Returns FALSE if there was an error.
// ====================================================================
HOUSEBOT_DEVICE_API BOOL HBDeviceRegisterProperties( int nDeviceNumber )
{
	return g_pWrapper->HBDeviceRegisterProperties(nDeviceNumber);
}

// ====================================================================
// Method Name : HBDeviceInit
// Description : The server calls this function to allow the Device
//                instance to initialize.
// Parameters  : hDevice - Handle to the Device to initialize.
//               bEnabled - Boolean value indicating the startup enabled
//                state of the Device.
//               szDeviceName - Character string indicating the device
//                name that is being initialized.  This is the same name
//                passed in the ModuleInfo structure.  This value allows
//                the plugin to create unique Device objects based on the
//                type/name of the Device.
//               szDeviceDescription - Character string that the user has
//                configured for the Device.  Mainly used to help identify
//                the device when tracing.
// Notes       : This is the first function called by the server that includes
//                the Device Handle (DEVICE_HANDLE).  This is the time to
//                create Device instance objects to maintain
//                per-instance state.
// Returns     : Returns TRUE if successful.  Returns FALSE if unsuccessful.
// ====================================================================
HOUSEBOT_DEVICE_API BOOL HBDeviceInit( DEVICE_HANDLE hDevice, BOOL bEnabled, const char* szDeviceName, const char* szDeviceDescription )
{
	return g_pWrapper->HBDeviceInit(hDevice, bEnabled, szDeviceName, szDeviceDescription);
}

// ====================================================================
// Method Name : HBDeviceSetEnabled
// Description : The server calls this function to indicate to the Device
//                that the user has changed the enabled state of the Device.
// Parameters  : hDevice - Device Handle
//               bEnabled - Boolean value indicating the new Enabled state.
// Notes       : The Device should honor the enabled state.  Typically this
//                means to ignore changes from Property Values when in a
//                disabled state.  It is best to process property value
//                updates, but NOT mark them as complete.  It is possible,
//                however, to process some property values and not others
//                in this state.  For example, the Device may wish to handle
//                non-critical settings in a disabled state, but ignore
//                more 'active' property value changes.
// Returns     :  Returns TRUE if successful.  Returns FALSE if unsuccessful.
// ====================================================================
HOUSEBOT_DEVICE_API BOOL HBDeviceSetEnabled( DEVICE_HANDLE hDevice, BOOL bEnabled )
{
	return g_pWrapper->HBDeviceSetEnabled(hDevice, bEnabled);
}

// ====================================================================
// Method Name : HBDeviceRun
// Description : The server calls this function to allow the Device to run.
// Parameters  : hDevice - Device Handle
//               hTerminate - Windows Event handle that will be set when the
//                server requires the Device to terminate.
//               hPropertyChangeRequest - Windows Event handle that will be
//                set when a property value that is managed by the Device
//                has changed.
// Notes       : The HBDeviceRun() function should not return until the
//                hTerminate event has been set by the server.  The server
//                will create a thread for each Device instance and call
//                HBDeviceRun() expecting the Device to block (using
//                WaitForMultipleObjects()).  If hTermiate is set, the Device
//                should cleanup and return.  If hPropertyChangeRequest is set,
//                the Device should retrieve and process the next property change
//                request in the Device queue.  The Device can also wait on it's
//                own Events and do it's own internal work.
// Returns     : Returns TRUE if successful.  Returns FALSE if unsuccessful.
// ====================================================================
HOUSEBOT_DEVICE_API BOOL HBDeviceRun( DEVICE_HANDLE hDevice, HANDLE hTerminate, HANDLE hPropertyChangeRequest )
{
	return g_pWrapper->HBDeviceRun( hDevice, hTerminate, hPropertyChangeRequest );
}

// ====================================================================
// Method Name : HBDisplayHelp
// Description : The server calls this function when the user requests help.
// Parameters  : szDeviceName - Name of Device.  If the Plugin supports multiple
//                Devices, this name is used to determine which Device
//                help should be displayed.
// Notes       : The HBDisplayHelp() function should display help for
//                the plugin.  The help can be in any form, but it is
//                suggested, for consistency, that the help be in
//                HTMLHelp format.
// ====================================================================
HOUSEBOT_DEVICE_API void HBDisplayHelp( const char* szDeviceName )
{
	g_pWrapper->HBDisplayHelp( szDeviceName );
}

// ====================================================================
// Method Name : HBAboutBox
// Description : The server calls this function when the user presses the about box button.
// Parameters  : szDeviceName - Name of Device.  If the Plugin supports multiple
//                Devices, this name is used to determine which Device
//                about box should be displayed.
// ====================================================================
HOUSEBOT_DEVICE_API void HBAboutBox( const char* szDeviceName )
{
	g_pWrapper->HBAboutBox( szDeviceName );
}

// ====================================================================
// Method Name : HBDeviceButtonPressNotification
// Description : The server calls this function when the user presses a
//                Property Button.
// Parameters  : hDevice - Device Handle
//               nButtonID - Unique button ID that was passed in pHB_RegisterDeviceButton()
// ====================================================================
HOUSEBOT_DEVICE_API void HBDeviceButtonPressNotification( DEVICE_HANDLE hDevice, int nButtonID )
{
	g_pWrapper->HBDeviceButtonPressNotification( hDevice, nButtonID );
}

// ====================================================================
// Method Name : HBDeviceSubscriptionNotification
// Description : This method is called when any Hardware Interface sends
//                a subscription notification that matches the list name
//                and filter previously registered by this device.
// Parameters  : szListName - Name of the list.  This will match exactly the name of the list
//                as it was registered by the Device.  If subscribing to multiple lists, this
//                name can be used to differentiate between the different notifications.
//               szFilter - Filter that was used by the device to register the list.
//               pDataPack - Pointer to a CDataPack object that was sent from the Hardware Interface.
//                The data that is in the list is specific to the list itself.
// ====================================================================
HOUSEBOT_DEVICE_API BOOL HBDeviceSubscriptionNotification( DEVICE_HANDLE hDevice, LPCTSTR szListName, LPCTSTR szFilter, CDataPack* pDataPack )
{
	return g_pWrapper->HBDeviceSubscriptionNotification( hDevice, szListName, szFilter, pDataPack );
}

// ====================================================================
// Method Name : HBPropertyChangeNotification
// Description : This method is called when any Propperty Value that has been
//                previously subscribed to with pHB_SubscribeToPropertyChange() changes.
// Parameters  : szDeviceDescription - Description of the Device that the property change on.
// 				  szPropertyDescription - Description of Property that changed.
// 				  szNewValue - New value of the Property.
// ====================================================================
HOUSEBOT_DEVICE_API void HBPropertyChangeNotification( DEVICE_HANDLE hDevice, const char* szDeviceDescription, const char* szPropertyDescription, const char* szNewValue )
{
	g_pWrapper->HBPropertyChangeNotification( hDevice, szDeviceDescription, szPropertyDescription, szNewValue );
}